LIBS=-lm
INCLUDES=-I../../include
OBJS=../../obj/bdlffmc.o \
	 ../../obj/emissions.o \
	 ../../obj/energy.o \
	 ../../obj/eqffmc.o \
	 ../../obj/fbp_2021.o \
	 ../../obj/fbp_2021_pro.o \
	 ../../obj/fgmgrid.o \
	 ../../obj/fwi84.o \
     ../../obj/geo90.o \
     ../../obj/get_xy.o \
     ../../obj/grids.o \
     ../../obj/hrffmc.o \
	 ../../obj/julian.o \
	 ../../obj/overlap.o \
	 ../../obj/plume.o \
	 ../../obj/reademissions.o \
	 ../../obj/readfeps.o \
	 ../../obj/readhotspotdata.o \
	 ../../obj/readprofile.o \
	 ../../obj/thermo.o \
	 ../../obj/writefeps.o \

CFFEPS.exe: CFFEPS.c $(OBJS)
	gcc CFFEPS.c -o1 -o CFFEPS.exe $(OBJS) $(LIBS) $(INCLUDES)



../../obj/bdlffmc.o: ../diurnal/bdlffmc.c
	gcc -c ../diurnal/bdlffmc.c -o ../../obj/bdlffmc.o $(INCLUDES)

../../obj/CFFEPS.o: CFFEPS.c
	gcc -c CFFEPS.c -o ../../obj/CFFEPS.o  $(INCLUDES)

../../obj/emissions.o: emissions.c
	gcc -c emissions.c -o ../../obj/emissions.o  $(INCLUDES)

../../obj/energy.o: energy.c
	gcc -c energy.c -o ../../obj/energy.o  $(INCLUDES)

../../obj/eqffmc.o: ../diurnal/eqffmc.c
	gcc -c ../diurnal/eqffmc.c -o ../../obj/eqffmc.o $(INCLUDES)

../../obj/fgmgrid.o: fgmgrid.c
	gcc -c fgmgrid.c -o ../../obj/fgmgrid.o $(INCLUDES)

../../obj/hrffmc.o: ../diurnal/hrffmc.c
	gcc -c ../diurnal/hrffmc.c -o ../../obj/hrffmc.o $(INCLUDES)

../../obj/fbp_2021.o: ../fbp2021/fbp_2021.c
	gcc -c ../fbp2021/fbp_2021.c -o ../../obj/fbp_2021.o  $(INCLUDES)

../../obj/fbp_2021_pro.o: ../fbp2021/fbp_2021_pro.c
	gcc -c ../fbp2021/fbp_2021_pro.c -o ../../obj/fbp_2021_pro.o  $(INCLUDES)

../../obj/fwi84.o: ../fwi84/fwi84.c
	gcc -c ../fwi84/fwi84.c -o ../../obj/fwi84.o $(INCLUDES)

../../obj/geo90.o: ../geo90/geo90.c
	gcc -c ../geo90/geo90.c -o ../../obj/geo90.o $(INCLUDES)

../../obj/get_xy.o: ../utils/get_xy.c
	gcc -c ../utils/get_xy.c -o ../../obj/get_xy.o $(INCLUDES)

../../obj/grids.o: ../utils/grids.c
	gcc -c ../utils/grids.c -o ../../obj/grids.o $(INCLUDES)

../../obj/julian.o: ../utils/julian.c
	gcc -c ../utils/julian.c -o ../../obj/julian.o $(INCLUDES)

../../obj/overlap.o: ../utils/overlap.c
	gcc -c ../utils/overlap.c -o ../../obj/overlap.o $(INCLUDES)

../../obj/plume.o: plume.c
	gcc -c plume.c -o ../../obj/plume.o  $(INCLUDES)

../../obj/reademissions.o: ../utils/reademissions.c
	gcc -c ../utils/reademissions.c -o ../../obj/reademissions.o  $(INCLUDES)

../../obj/readfeps.o: ../utils/readfeps.c
	gcc -c ../utils/readfeps.c -o ../../obj/readfeps.o  $(INCLUDES)

../../obj/readhotspotdata.o: ../utils/readhotspotdata.c
	gcc -c ../utils/readhotspotdata.c -o ../../obj/readhotspotdata.o  $(INCLUDES)

../../obj/readprofile.o: ../utils/readprofile.c
	gcc -c ../utils/readprofile.c -o ../../obj/readprofile.o  $(INCLUDES)

../../obj/thermo.o: ../thermo/thermo.c
	gcc -c ../thermo/thermo.c -o ../../obj/thermo.o $(INCLUDES)

../../obj/writefeps.o: ../utils/writefeps.c
	gcc -c ../utils/writefeps.c -o ../../obj/writefeps.o  $(INCLUDES)



