#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pfas.h"
//#include "malloc.h"

void Albers();
void Lambert();
void Polar();
void utm();
void get_xy();
// void Error();

FILE *prjfile;
FILE *infile;

int get_wxstn(char *ids[MAX_STNS], double *xs, double *ys, double *elevs)
{
char wxstnfilename[120], buffer[120], id[25], *args[10], *token;
double x, y, lat, lng, elev;
int i, j, k, iWxStn;

//	printf("Reading weather stations...\n");
	sprintf(wxstnfilename, "%swxstn.dat", filepath);

	for (i=0;i<MAX_STNS;i++)
	{
		ids[i] = (char *)malloc(ID_SIZE);
		strncpy(ids[i], "missing", ID_SIZE);
	}

	iWxStn=0;

	for (i=0;i<10;i++)
		args[i] = (char *)malloc(25);

  	if ( (infile = fopen(wxstnfilename, "r")) != NULL)
	{
		fgets(buffer, 120, infile);
 		while( !feof( infile ) )
		{
			j=0;

			token = strtok(buffer, " ");
			while (token != NULL)
			{
				strcpy(args[j], token);
				token = strtok(NULL, " ");
				j++;
			}

			lat = atof(args[j-3]);
			lng =  atof(args[j-2]);
			elev =  atof(args[j-1]);

			strcpy(id,"");
			for (k=0;k<j-3;k++)
			{
				strcat(id, args[k]);
				if (k<j-4)
					strcat(id, " ");
			}
			x=0.; y=0.;
			get_xy(&x, &y, &lat, &lng);
			strcpy(ids[iWxStn], id);
			xs[iWxStn] = x;
			ys[iWxStn] = y;
			elevs[iWxStn] = elev;
//			printf("'%s' %lf %lf %lf\n", ids[iWxStn],xs[iWxStn],ys[iWxStn],elevs[iWxStn]);
			iWxStn++;
			fgets(buffer, 120, infile);
		}
		fclose(infile);

		get_xy(&x, &y, &lat, &lng);

		return (iWxStn);
	}
	else
		return(-1);
}

void get_xy(double *X, double *Y, double *Lat, double *Lng, char * prjfilename)
{
double x, y, xo, yo, lat, lng, lato, lngo, Xshift, Yshift, d, m, s,
       theta1,theta2,meridian,origin,feasting,fnorthing;

char Projection[16],
     Datum[16],
	 Zunits[16],
	 Units[16],
	 Spheroid[16],
//	 prjfilename[120],
     buffer[120];

int Zone, z, hemisphere, zero=0;

/* Read the projection data */
//   sprintf(prjfilename, "%sfbp.prj", filepath);

   if ( (prjfile = fopen(prjfilename, "r")) != NULL)
   {
      fscanf(prjfile,"%s", buffer );
	  while( !feof( prjfile ) )
	  {

/* Projection */
         if ( !strcasecmp( buffer,"Projection" ) )
            fscanf(prjfile,"%s", Projection);

/* Zone */
         if ( !strcasecmp( buffer,"Zone" ) )
            fscanf(prjfile,"%d", &Zone);

/* Datum */
         if ( !strcasecmp( buffer,"Datum" ) )
            fscanf(prjfile,"%s", Datum);

/* Zunits */
         if ( !strcasecmp( buffer,"Zunits" ) )
            fscanf(prjfile,"%s", Zunits);

/* Units */
         if ( !strcasecmp( buffer,"Units" ) )
            fscanf(prjfile,"%s", Units);

/* Spheroid */
         if ( !strcasecmp( buffer,"Spheroid" ) )
            fscanf(prjfile,"%s", Spheroid);

/* Xshift */
         if ( !strcasecmp( buffer,"Xshift" ) )
            fscanf(prjfile,"%lf", &Xshift);

/* Yshift */
         if ( !strcasecmp( buffer,"Yshift" ) )
            fscanf(prjfile,"%lf", &Yshift);

/* Parameters */
         if ( !strcasecmp( buffer,"Parameters" ) )
		 {
/*            if (!strcasecmp(Projection, "LAMBERT")) / * Note that LAMBERT seems to have all these embedded comments * /
			{
/ * 1st standard parallel * /
               fscanf( prjfile," %lf %lf %lf %s %s %s %s", &d, &m, &s, buffer, buffer, buffer, buffer);
               if (d >= 0)
   			      theta1 = d + m/60.+ s/3600.;
			   else
                  theta1 = d - m/60.- s/3600.;

/ * 2nd standard parallel * /
               fscanf( prjfile," %lf %lf %lf %s %s %s %s", &d, &m, &s, buffer, buffer, buffer, buffer);
			   if (d >= 0)
   			      theta2 = d + m/60.+ s/3600.;
			   else
                  theta2 = d - m/60.- s/3600.;

/ * central meridian * /
               fscanf( prjfile," %lf %lf %lf %s %s %s", &d, &m, &s, buffer, buffer, buffer);
			   if (d >= 0)
   			      meridian = d + m/60.+ s/3600.;
			   else
                  meridian = d - m/60.- s/3600.;

/ * origin * /
               fscanf(prjfile," %lf %lf %lf %s %s %s %s %s", &d, &m, &s, buffer, buffer, buffer, buffer, buffer);
			   if (d >= 0)
   			      origin = d + m/60.+ s/3600.;
			   else
                  origin = d - m/60.- s/3600.;

/ * false easting (metres) * /
               fscanf( prjfile," %lf %s %s %s %s", &feasting, buffer, buffer, buffer, buffer);

/ * false northing (metres) * /
               fscanf( prjfile," %lf %s %s %s %s", &fnorthing, buffer, buffer, buffer, buffer);
			} / * End of Lambert projection parameters */

			if (!strcasecmp(Projection, "LAMBERT") ||
				!strcasecmp(Projection, "ALBERS")) /* ALBERTS doesn't have the embedded comments */
			{

/* Note: ESRI sometimes pads the line with lots of blanks (to 80+?) */

/* 1st standard parallel */
			   fgets(buffer, 120, prjfile ); /* apparently there is still a \n to read in */
			   fgets(buffer, 120, prjfile );
			   sscanf(buffer,"%lf %lf %lf", &d, &m, &s);
               if (d >= 0)
   			      theta1 = d + m/60.+ s/3600.;
			   else
                  theta1 = d - m/60.- s/3600.;

/* 2nd standard parallel */
			   fgets(buffer, 120, prjfile );
			   sscanf(buffer,"%lf %lf %lf", &d, &m, &s);
			   if (d >= 0)
   			      theta2 = d + m/60.+ s/3600.;
			   else
                  theta2 = d - m/60.- s/3600.;

/* central meridian */
			   fgets(buffer, 120, prjfile );
			   sscanf(buffer,"%lf %lf %lf", &d, &m, &s);
			   if (d >= 0)
   			      meridian = d + m/60.+ s/3600.;
			   else
                  meridian = d - m/60.- s/3600.;

/* origin */
   			   fgets(buffer, 120, prjfile );
			   sscanf(buffer,"%lf %lf %lf", &d, &m, &s);
			   if (d >= 0)
   			      origin = d + m/60.+ s/3600.;
			   else
                  origin = d - m/60.- s/3600.;

/* false easting (metres) */
   			   fgets(buffer, 120, prjfile );
               sscanf( buffer,"%lf", &feasting);

/* false northing (metres) */
   			   fgets(buffer, 120, prjfile );
               sscanf( buffer,"%lf", &fnorthing);

//			   printf("x: %lf %lf %lf %lf %lf %lf\n", theta1, theta2, meridian, origin, feasting, fnorthing);
			} /* End of ALBERS projection parameters */

			else if (!strcasecmp(Projection, "UTM"))
			{
			   origin = 0.;
			   meridian = (Zone * 6. - 183.);
			   feasting = 500000.;
			   fnorthing=0.;
			}
		 }
	     fscanf(prjfile,"%s", buffer );
	  }
	  fclose (prjfile);
   }
   else
   {
	  sprintf(buffer, "%s not found", prjfilename);
	  printf("%s\n", buffer);
//	  Error(buffer);

/* default values */
		strcpy(Projection, "LAMBERT");
		theta1 = 49.;
		theta2 = 77.;
		meridian = -112;
		origin = 49.;
		feasting = 0.;
		fnorthing = 0.;
   }

//	fclose (prjfile);

	lato = origin; lngo = meridian;
	lat = *Lat;
	lng = *Lng;
	y = *Y;
	x = *X;

/* Catch the possible case of X and Y undefined */
	if (lat>=-90. && lat <=90. && lng >= -180. && lng <= 180.  && (lat !=0. && lng !=0.) )
	{
		x=0.; y=0.;
		*X = x; *Y = y;
	}

/* These next two conditions account for the possible reversal of X/Y and Lat/Lng */
	if (lat < -90. || lat > 90. || lng < -180. || lng > 180.)
	{
		x = lng; y = lat;	/* these values now assumed to be projection coordinates */
		*X = x; *Y = y;
		lat=0.; lng=0.;		/* and we reset lat,lng */
	}

	if (y >= -90. && y <= 90. && x >= -180. && x <= 180.  && (y != 0. && x != 0.) )
	{
		lng = x; lat = y;	/* these values now assumed to be projection coordinates */
		*Lat = lat; *Lng = lng;
		x=0.; y=0.;		/* and we reset lat,lng */
	}

/* Convert from lat-lng to x-y */
   if (lat>=-90. && lat <=90. && lng >= -180. && lng <= 180.  && (lat !=0. && lng !=0.) )
   {
	    xo =0.; yo=0.;   /* coordinates at origin */
		x=0.; y=0.;      /* coordinates of location */

		if (!strcasecmp(Projection, "ALBERS") )
		{
			Albers(&xo, &yo, &lato, &lngo, &meridian, &theta1, &theta2);
			Albers(&x, &y, &lat, &lng, &meridian, &theta1, &theta2);
		}
		if (!strcasecmp(Projection, "LAMBERT") )
		{
			Lambert(&xo, &yo, &lato, &lngo, &meridian, &theta1, &theta2);
			Lambert(&x, &y, &lat, &lng, &meridian, &theta1, &theta2);
		}
		if (!strcasecmp(Projection, "POLAR") )
		{
			Polar(&xo, &yo, &lato, &lngo, &lato, &lngo, &meridian);
			Polar(&x, &y, &lat, &lng, &lato, &lngo, &meridian);
		}
		if (!strcasecmp(Projection, "UTM") )
		{
			hemisphere = 1;  /* always use Northern hemisphere for now */
			z = -Zone; /* convert lat-lng of origin to UTM using the projection zone */
			utm(&lato, &lngo, &xo, &yo, &z, &hemisphere);
			z = -Zone; /* convert lat-lng of ignition pt to UTM using the projection zone*/
			utm(&lat, &lng, &x, &y, &z, &hemisphere);
		}
/* coordinates of location w.r.t. origin */
		*X = x-xo+feasting;
		*Y = y-yo+fnorthing;
	}

/* Convert from x-y to lat-lng */
	else
	{
		xo=0.; yo=0.;		/* coordinates at origin */

		if (!strcasecmp(Projection, "ALBERS") )
		{
			Albers(&xo, &yo, &lato, &lngo, &meridian, &theta1, &theta2);
			x = x+xo-feasting;
		    y = y+yo-fnorthing;
			Albers(&x, &y, &lat, &lng, &meridian, &theta1, &theta2);
		}

		if (!strcasecmp(Projection, "LAMBERT") )
		{
			Lambert(&xo, &yo, &lato, &lngo, &meridian, &theta1, &theta2);
			x = x+xo-feasting;
		    y = y+yo-fnorthing;
			Lambert(&x, &y, &lat, &lng, &meridian, &theta1, &theta2);
		}

		if (!strcasecmp(Projection, "POLAR") )
		{
			Polar(&xo, &yo, &lato, &lngo, &lato, &lngo, &meridian);
			x = x+xo-feasting;
		    y = y+yo-fnorthing;
			Polar(&x, &y, &lat, &lng, &lato, &lngo, &meridian);
		}
		if (!strcasecmp(Projection, "UTM") )
		{
			hemisphere = 1;  /* always use Northern hemisphere for now */
			z = -Zone; /* convert lat-lng of origin to UTM using the projection zone */
			utm(&lato, &lngo, &xo, &yo, &z, &hemisphere);

			z = Zone; /* calculate lat-lng of ignition pt using UTM in the projection zone */
			x = x+xo-feasting;
		    y = y+yo-fnorthing;
			utm(&lat, &lng, &x, &y, &z, &hemisphere);
		}

		*Lat=lat;
		*Lng=lng;

	}

}
