#include <stdio.h>
#include <math.h>

/* This routine calculates the overlap (in hectares) of two hotspots
   (based on solution from https://diego.assencio.com/?index=8d6ca3d82151bad815f78addf9b5c1c6 */

double overlap(double lat1, double long1, double estarea1, double lat2, double long2, double estarea2)
{
double C1, C2, r1, r2, pi=3.1415926;
double dx, dy, d, d1, d2, A;

// C1 >= C2
    if (estarea1>=estarea2)
    {
        C1=estarea1;
        C2=estarea2;
    }
    else
    {
        C2=estarea1;
        C1=estarea2;
    }

// r1 >= r2
    r1 = sqrt(10000.*C1/pi); // m
    r2 = sqrt(10000.*C2/pi); // m

    dx = 111000. * cos(pi/180.*(lat1+lat2)/2.) * (long1-long2);
    dy = 111000. * (lat1-lat2);
    d = sqrt(dx*dx + dy*dy);

    if (d >= r1+r2)
        A = 0.;
    else if (d < (r1-r2)  )
        A = C2;
    else
    {
        d1 = (r1*r1 - r2*r2 + d*d)/(2.*d);
        d2 = d - d1;

        A = r1*r1*acos(d1/r1) - d1*sqrt((r1*r1) - d1*d1)
          + r2*r2*acos(d2/r2) - d2*sqrt((r2*r2) - d2*d2);  // acos in radians
    }

    A = A/10000.;

//printf("%lf %lf %lf %lf %lf %lf ", A, C1, C2, r1, r2, d);
//printf("%lf %lf %lf %lf %lf %lf\n", lat1, lat2, dy, long1, long2, dx);

return (A);
}
