#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#include "feps_2011.h"
#include "fbp_2021.h"
//#include "malloc.h"
double T_d_Calc();
double e_w_Calc();
double BUIcalc();
double GSIcalc();
int GLC2000Type();
int Peatland();

FILE *infile;

/* Interpretes Global Land Cover 2000 into FBP fuel type */

int GLC2000Type(FEPS *feps, FBP *fbp)
{
    char *glcFuels[23][19] =
/* Region
   0     1     2     3     4     5     6     7     8     9     10    11    12    13    14    15    16    17    18
   A     B     C     D     E     F     G     H     I     J     K     L     M     N     O     P     Q     R     S */
{ "D2", "D2", "D2", "D2", "D2", "D2", "x",  "D2", "x",  "D2", "D2", "D2", "C2", "x",  "x",  "D2", "D2", "D2", "D2", // 1
  "D1", "D1", "D1", "D1", "D1", "D1", "D1", "D1", "D1", "D1", "D1", "D1", "x",  "x",  "x",  "x",  "x",  "x",  "x",  // 2
  "D1", "O1", "D1", "D1", "D1", "x",  "D1", "D1", "x",  "D1", "D1", "x",  "C2", "x",  "x",  "D1", "x",  "x",  "x",  // 3
  "x",  "x",  "C23","C3", "C3", "C3","C23", "C3", "C3", "C3","C23","C23", "x",  "C3", "x",  "x",  "x",  "x",  "x",  // 4
  "x",  "x",  "M1", "M1", "x",  "x",  "M1", "x",  "x",  "x",  "M1", "x",  "x",  "x",  "x",  "x",  "x",  "x",  "x",  // 5
  "D1", "x",  "M1", "D1", "x",  "x",  "M1", "M1", "M1", "M1", "M1", "M1", "x",  "M1", "x",  "x",  "x",  "x",  "x",  // 6
  "TM", "TM", "x",  "x",  "x",  "TM", "TM", "x",  "x",  "x",  "x",  "TM", "x",  "x",  "x",  "x",  "x",  "x",  "x",  // 7
  "NF", "NF", "x",  "x",  "NF", "NF", "x",  "NF", "x",  "x",  "x",  "x",  "TM", "x",  "x",  "x",  "x",  "NF", "x",  // 8
  "x",  "D1", "M1", "x",  "M1", "D1", "M1", "M1", "x",  "M1", "M1", "C1", "M1", "x",  "x",  "D1", "M1", "M1", "M1", // 9
  "x",  "x",  "NF", "NF", "x",  "x",  "NF", "x",  "x",  "x",  "NF", "NF", "x",  "x",  "x",  "x",  "x",  "x",  "x",  // 10
  "D2", "x",  "C1", "x",  "D2", "D2", "C1", "C3", "O1", "O1", "O1", "O1", "x",  "x",  "x",  "O1", "O1", "x",  "O1", // 11
  "D1", "D1", "M1", "D1", "D1", "D1", "D1", "D1", "D1", "D1", "D1", "O1", "C2", "D1", "D1", "D1", "x",  "x",  "O1", // 12
  "O1", "O1", "TM", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "x",  "x",  "O1", // 13
  "O1", "O1", "C1", "C1", "NF", "O1", "O1", "NF", "O1", "O1", "NF", "NF", "O1", "x",  "NF", "x",  "x",  "x",  "NF", // 14
  "OM", "OM", "OM", "OM", "OM", "x",  "OM", "OM", "OM", "OM", "OM", "OM", "O1", "x",  "OM", "x",  "x",  "x",  "x",  // 15
  "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "x",  "O1", "O1", "O1", "O1", // 16
  "D1", "D1", "D1", "D1", "D1", "D1", "D1", "D1", "x",  "x",  "D1", "D1", "D1", "x",  "x",  "x",  "D1", "x",  "D1", // 17
  "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "O1", "x",  "O1", "x",  "O1", "x",  "x",  "x",  // 18
  "NF", "NF", "NF", "NF", "NF", "NF", "NF", "x",  "x",  "NF", "NF", "x",  "NF", "NF", "NF", "NF", "x",  "NF", "NF",  // 19
  "NF", "NF", "NF", "NF", "NF", "NF", "NF", "x",  "NF", "NF", "NF", "NF", "NF", "NF", "NF", "x",  "NF", "NF", "NF",  // 20
  "NF", "x",  "NF", "NF", "NF", "NF", "NF", "NF", "x",  "NF", "NF", "NF", "x",  "x",  "NF", "x",  "x",  "NF", "NF",  // 21
  "NF", "NF", "NF", "NF", "NF", "NF", "NF", "NF", "NF", "NF", "NF", "NF", "NF", "NF", "NF", "x",  "x",  "NF", "NF",  // 22
  "x",  "x",  "x",  "x",  "x",  "x",  "x",  "x",  "x",  "x",  "x",  "x",  "x",  "x",  "x",  "x",  "x",  "x",  "x" }; // 23


/*

GLC2000 :
    1.        Tree Cover, broadleaved, evergreen
    2.        Tree Cover, broadleaved, deciduous, closed
    3.        Tree Cover, broadleaved, deciduous, open
    4.        Tree Cover, needle-leaved, evergreen
    5.        Tree Cover, needle-leaved, deciduous
    6.        Tree Cover, mixed leaf type
    7.        Tree Cover, regularly flooded, fresh  water (& brackish)
    8.        Tree Cover, regularly flooded, saline water
    9.        Mosaic:  Tree cover / Other natural vegetation
    10.        Tree Cover, burnt
    11.        Shrub Cover, closed-open, evergreen
    12.        Shrub Cover, closed-open, deciduous
    13.        Herbaceous Cover, closed-open
    14.        Sparse Herbaceous or sparse Shrub Cover
    15.        Regularly flooded Shrub and/or Herbaceous Cover
    16.        Cultivated and managed areas
    17.        Mosaic: Cropland / Tree Cover / Other natural vegetation
    18.        Mosaic: Cropland / Shrub or Grass Cover
    19.        Bare Areas
    20.        Water Bodies (natural & artificial)
    21.        Snow and Ice (natural & artificial)
    22.        Artificial surfaces and associated areas
    23.        No data

region:

    A    South America(0)
    B    Africa (1)
    C    Northern Eurasia (2)
    D    Asia (Middel East, Japan, Korea) (3)
    E    South Asia (Pakistan, India, Burma) (4)
    F    South East Asia (5)
    G    Europe – North East Europe (6)
    H    Europe (7)
    I    North West Europe (8)
    J    Southern Europe (9)
    K    China (10)
    L    North America (11)
    M    Australia (12)
    N    New Zealand (13)
    O    Greenland Iceland (14)
    P    Solomon Islands (15)
    Q    New Caledonia and Vanuatu (16)
    R    Fijian Islands (17)
    S    Hawaiian Islands (18)
*/

/* Default FBP values (0 will force FBPCalc() to use the default SFL, CFL values [kg/m2] )
    double SFLs[23] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    double CFLs[23] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    double GFLs[23] = { 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35, 0.35}; */


/*  van Leeuwen (2014)   1     2     3     4    5   6     7     8   9    10  11    12    13    14    15    16    17    18   19  20  21  22  23 */
    double SFLs[23] = {11.79, 1.13, 0.58, 2.49, 0, 1.49, 4.53,  0, 4.97,  0, 2.03, 1.04, 0.13, 0.13, 8.44, 1.12, 4.49, 0.00, 0,  0,  0,  0,  0};
    double CFLs[23] = { 0.35, 0.00, 0.07, 0.52, 0, 0.03, 0.00,  0, 0.29,  0, 0.00, 0.01, 0.00, 0.00, 0.00, 0.10, 0.14, 0.00, 0,  0,  0,  0,  0};
    double GFLs[23] = { 0.06, 0.00, 0.04, 0.00, 0, 0.01, 0.00,  0, 0.00,  0, 0.00, 0.04, 0.12, 0.00, 0.00, 0.01, 0.11, 0.46, 0,  0,  0,  0,  0};
/* these values are based on the average SFL/CFL/GFL of points reported in Leeuwen2014_corrected.xlsx sampled against GLC2000 land cover (see Summary.xlsx) */

/* van der Werf (2017)
    double SFLs[23] = {12.15, 0.58, 1.14,10.20, 0, 8.47, 0.00,  0, 0.00,  0,14.00, 0.56, 1.64, 0.80, 3.70, 5.73,23.98, 5.58, 0,  0,  0,  0,  0};
    double CFLs[23] = { 0.00, 0.00, 0.00,16.37, 0, 0.00, 0.00,  0, 0.00,  0, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0,  0,  0,  0,  0};
    double GFLs[23] = { 0.00, 0.00, 0.00, 0.00, 0, 0.00, 0.00,  0, 0.00,  0, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0,  0,  0,  0,  0}; */

/*

From van der Werf - 2017-FCdata_Dec2014.xlsx

Biome        1,  1.1,  1.2,    2,     3,    4,    5,    6,    7,    8,      9,   10,   11
			SA,   GS,   WS,   TF,    TM,   BF,   PA,   SC,   CR,   CH,     TP,   BP,   TU
FL (t/ha): 7.6,  5.3, 11.0, 284.7, 115.4, 68.7, 73.8, 44.0,  8.3, 34.7, 1055.6,    -, 165
CC (%):	  71.3, 81.0, 58.0,  48.6,  61.1, 51.0, 47.4, 46.8, 74.5, 75.8,   27.2,    -,  24
FC (t/ha): 4.6,  4.3,  5.1, 125.5,  57.8, 34.7, 28.4, 23.4,  6.5, 27.2,  313.6, 42.3,  40

                       0    1       2      3     4      5      6      7      8     9    10      11    12    13  14    15 16
                       0    4       2      4     3      3      8      8      1.2   1.1   1    9/10     5     0   5     0  0
    double FLs[17] = { 0.,  6.87,  28.47, 6.87, 11.54, 11.54,  3.47,  3.47,  1.10, 0.53, 0.76, 105.56, 7.38, 0,  7.38, 0, 0};
	double CCs[17] = { 0., 51.  ,  48.6, 51.  , 61.1,  61.1 , 75.8 , 75.8 , 58.0, 81.0, 71.3,   27.2, 47.4 , 0, 47.4 , 0, 0};
	double FCs[17] = { 0.,  3.47, 12.55,  3.47,  5.78,  5.78,  2.72,  2.72,  0.51, 0.43,  0.46, 31.36, 2.84, 0,  2.84, 0, 0};


    double FLs[11] = { 7.6, 284.7, 115.4, 68.7, 73.8, 44.0,  8.3, 34.7, 1055.6,    0, 165};
    double CCs[11] = {71.3,  48.6,  61.1, 51.0, 47.4, 46.8, 74.5, 75.8,   27.2,    0,  24};
    double FCs[11] = { 4.6, 125.5,  57.8, 34.7, 28.4, 23.4,  6.5, 27.2,  313.6, 42.3,  40};

	1.  Savanna
	1.1	Grassland Savanna
	1.2	Wooded Savanna
	2.	Tropical Forest
	3.	Temperate Forest
	4.	Boreal Forest
	5.	Pasture
	6.	Shifting Cultivation
	7.	Crop Residue
	8.	Chaparral
	9.	Tropical Peat
	10.	Boreal Peat
	11.	Tundra

1.	Evergreen Needleleaf Forests		[4]		[PNW coast, Sweden, Finland]
2.	Evergreen Broadleaf Forests			[2]		[Congo, Amazon, Borneo]
3.	Deciduous Needleleaf Forests		[4]		[Siberia]
4.	Deciduous Broadleaf Forests			[3]		[Prairies, Great Lakes, Eastern US, Carpathian, Caucasus]
5.	Mixed Forests						[3]		[Ontario, Quebec, Russia]
6.	Closed Shrublands					[8]		[Australia, Angola/Namibia
7.	Open Shrublands						[8]		[South Africa, Namibia, Australian outback]
8.	Woody Savannas						[1.2]		[Congo, Zambia, Liberia, Java]
9.	Savannas							[1/1.1]		[Guinea, Tanzania, Brazil]
10.	Grasslands							[1]		[Colorado, Brazil, Chad, Mali, Ehtiopia]
11.	Permanent Wetlands					[9/10]		[
12.	Croplands							[5]		[US midwest, Can Prairies, Thailand, India, China]
13.	Urban and Built-up Lands			[0]
14.	Cropland/Natural Vegetation Mosaics	[5]
15.	Permanent Snow and Ices				[0]
16.	Barren								[0]

*/
    double FLs[17] = { 0.,  6.87,  28.47, 6.87, 11.54, 11.54,  3.47,  3.47,  1.10, 0.53, 0.76, 105.56, 7.38, 0,  7.38, 0, 0};
	double CCs[17] = { 0., 51.  ,  48.6, 51.  , 61.1,  61.1 , 75.8 , 75.8 , 58.0, 81.0, 71.3,   27.2, 47.4 , 0, 47.4 , 0, 0};
	double FCs[17] = { 0.,  3.47, 12.55,  3.47,  5.78,  5.78,  2.72,  2.72,  0.51, 0.43,  0.46, 31.36, 2.84, 0,  2.84, 0, 0};

/* Randerson et al 2012 (supplemental)
   Small Fire Boost
                       Globe   BONA    TENA    CEAM    NHSA    SHSA    EURO    MIDE    NHAF    SHAF    BOAS    CEAS    SEAS    EQAS    AUST */
    double SFB[15] = {0.3600, 0.1034, 1.4545, 3.5714, 0.8696, 0.3140, 1.6667, 1.5455, 0.3234, 0.3037, 0.9250, 0.7246, 0.6505, 5.5000, 0.1180};

//                     Globe        BONA         TENA         CEAM         NHSA         SHSA         EURO         MIDE        NHAF         SHAF         BOAS        CEAS          SEAS        EQAS         AUST */
// 	double Crops[15] = {158.0620881, 403.8919395, 662.6890577, 80.42383835, 23.46500532, 69.10944656, 334.0969917, 186.587471, 72.08039522, 74.06992206, 75.78544082, 302.3891369, 199.603475, 68.36404005, 132.1803072};
	double Crops[15] = {103.36,      409.43,      625.07,      68.40,       15.10,       76.94,       234.19,      177.09,     30.02,       50.56,       66.08,       216.82,      151.74,     56.95,       119.00};
/* these values are based on FAO data and hotspots -- see hotspot_counts_by_country_by_day_for_kerry.xlsx */


double a, x, GSI;
int status, region, i, j, greenup, standing;

    if (feps->glc_region[0] >= 'A' && feps->glc_region[0] <= 'S')
        region = feps->glc_region[0] - 'A';
    else if (feps->glc_region[0] >= 'a' && feps->glc_region[0] <= 's')
        region = feps->glc_region[0] - 'a';
    else
        region = -1;

    feps->region = region;

    if (region>=0 && feps->glc>=1 && feps->estarea>0.)  // added feps->estarea>0. in conditional -- 2022-02-28
        strcpy(fbp->FuelType, glcFuels[feps->glc-1][region]);
    else
        strcpy(fbp->FuelType, "NF");

    if (!strcasecmp(fbp->FuelType, "x")) strcpy(fbp->FuelType, "NF");

    if (!strcasecmp(fbp->FuelType, "C23")) strcpy(fbp->FuelType, "C2");   // identifying a fuel as C23 is recognizing it as either C2 or C3 (reassigned to C2 for now)


/* Outside of equatorial Asia, treed boreal peatlands were assigned to boreal mixedwood forest with 50% conifer trees (M-1/2 C50) when the DC is above 330 respectively, and D-2 at lower DC values.
   Open peatlands are a non-fuel until DC 650, at which point they are burn as fully cured standing grass (O-1b). These thresholds are based on Thompson et al. (2019). */
    if (!strcasecmp(fbp->FuelType, "TM"))
    {
        if (fbp->DC>330)
        {
            strcpy(fbp->FuelType, "M1");
            fbp->PC = 50;
        }
        else
            strcpy(fbp->FuelType, "D2");
    }
    if (!strcasecmp(fbp->FuelType, "OM"))
    {
        if (fbp->DC<650)
            strcpy(fbp->FuelType, "NF");
        else
            strcpy(fbp->FuelType, "O1B");
    }


    if (feps->glc<1)  // added conditional -- 2022-02-28
    {
        fbp->SFL = 0.;
        fbp->CFL = 0.;
        fbp->GFL = 0.;
		strcpy(fbp->FuelType, "NF");
    }
    else    /* New conditional to allow SFL, CFL and GFL 2022-03-28 */
    {
            fbp->SFL = SFLs[feps->glc-1];
            fbp->CFL = CFLs[feps->glc-1];
            fbp->GFL = GFLs[feps->glc-1];
    }

/*** new GSI approach for greenup ***/
    GSI = feps->GSI = feps->GSI21;  // GSI21 from the input file

    if (GSI < 0.) GSI = feps->GSI = GSIcalc(feps->tavg, feps->tmin, feps->tdavg, fbp->LAT, fbp->Dj);

    if (GSI > 0.5)
        greenup = standing = 1;
    else
        greenup = standing = 0;

/* Adjust fuels for greenup and standing (except for mixed wood, don't really use this) */
//    if (greenup == 1 && !strcasecmp(fbp->FuelType, "D1")) strcpy(fbp->FuelType, "D2");    // NOTE: if the original fuel is D2, it is assumed to be green year round (jungle)

    if (greenup >=0)
    {
        if (greenup == 1 && !strcasecmp(fbp->FuelType, "M1")) strcpy(fbp->FuelType, "M2");
        if (greenup == 0 && !strcasecmp(fbp->FuelType, "M2")) strcpy(fbp->FuelType, "M1");
        if (greenup == 1 && !strcasecmp(fbp->FuelType, "M3")) strcpy(fbp->FuelType, "M4");
        if (greenup == 0 && !strcasecmp(fbp->FuelType, "M4")) strcpy(fbp->FuelType, "M3");
    }

/* Greenup a continuous function of GSI */
    if (!strncasecmp(fbp->FuelType, "D", 1))
    {
        strcpy(fbp->FuelType, "D1");
        fbp->SFL = (1.-GSI) * fbp->SFL;
    }


/*** Grass curing a function of GSI ***/
	fbp->C = 100.*(1.-GSI);	// old aproach -- may use later

/*** Grass curing a function of DC ***/
	fbp->C = 100.*(1.-exp(-0.0027*fbp->DC));	// 2023-09-26

    if (standing >=0)
    {
        if (standing == 1 && !strncasecmp(fbp->FuelType, "O1", 2)) strcpy(fbp->FuelType, "O1b");
        if (standing == 0 && !strncasecmp(fbp->FuelType, "O1", 2)) strcpy(fbp->FuelType, "O1a");
    }

/*** Region specific fuel loads (those now assigned to D1 will not be affected by GSI ***/

/*** South America ***/
//    if (region == 0 && feps->glc == 1)
//        { strcpy(fbp->FuelType, "D1"); fbp->SFL = 24.9; fbp->CFL=0.; fbp->GFL=0.; }   // South America - Tropical Forest (old values)

    if (region != 12 && feps->glc == 1)													// Apply to ALL tropical forests (except eucalypt) -- 2023-11-01
        { strcpy(fbp->FuelType, "D1"); fbp->SFL = 18.28; fbp->CFL=0.; fbp->GFL=0.; }    // South America - Tropical Forest (SFL from Tropical Forests.xlsx)

    if (region == 0 && !strncasecmp(fbp->FuelType, "D1", 1) && feps->glc > 1)
        { strcpy(fbp->FuelType, "D1"); fbp->SFL = 1.663904118; fbp->CFL=0.; fbp->GFL=0.663011603; }   // South America - Savanna (SFL from Savanna test -  updated8.xlsx) - 2023-10-02


/*** Africa ***/
    if (region == 1 && !strncasecmp(fbp->FuelType, "O1", 1))
        { fbp->SFL=0.1065; fbp->CFL=0.; fbp->GFL=0.2189; }    // Africa - Dambo Grassland Savanna (SFL/GFL from Savanna test -  updated8.xlsx) - 2023-10-02

    if (region == 1 && !strncasecmp(fbp->FuelType, "D1", 1) && feps->glc > 1)	// use for all deciduous except jungle -- 2023-08-25
        { strcpy(fbp->FuelType, "D1"); fbp->SFL=0.3509; fbp->CFL=0.; fbp->GFL=0.0790; }    // Africa - Miombo Woody Savanna (SFL/GFL from Savanna test -  updated8.xlsx) - 2023-10-02


/*** Boreal Asia ***/
    if (region == 2 && !strncasecmp(fbp->FuelType, "C2", 2))
        { fbp->SFL = 5.0; fbp->CFL=0.8; fbp->GFL=0.;}    // Boreal Asia - Conifier (as described in supplemental paper)

/*** Boreal North America ***/
    if (region == 11 && !strncasecmp(fbp->FuelType, "C2", 2))
        { fbp->SFL = 5.0; fbp->CFL=1.0; fbp->GFL=0.;}    // Boreal North America - Conifer (CFL an average of C1,2,3,4)

/*** Australia ***/
    if (region == 12) // note: glcFuels[i][12] have been updated as well
    {
        if (feps->glc == 13) { strcpy(fbp->FuelType, "O1B"); fbp->SFL=0.; fbp->CFL=0.;  fbp->GFL=0.2; } // Herbaceous Cover, closed-open
        if (feps->glc == 14) { strcpy(fbp->FuelType, "O1B"); fbp->SFL=0.; fbp->CFL=0.;  fbp->GFL=1.1; } // Sparse Herbaceous or sparse Shrub Cover
        if (feps->glc == 15) { strcpy(fbp->FuelType, "O1B"); fbp->SFL=0.; fbp->CFL=0.;  fbp->GFL=0.2; } // Regularly flooded Shrub and/or Herbaceous Cover
        if (feps->glc == 16) { strcpy(fbp->FuelType, "O1B"); fbp->SFL=0.; fbp->CFL=0.;  fbp->GFL=0.4; } // Cultivated and managed areas

/*  	Eucalypt
		modified approach based on Oliveira forest cover amounts; remainder set as grass (4 t/ha).  Note: curing affects only grass fuel, not woody fuel
		using logistic curve (based on 18 fires), fuel load of 7.8 kg/m2, and 90% FC_max
		by assigning all to grass fuel load, FBP will burn 100%, thus avoiding SFC calculations for C2 */

        if (feps->glc == 1)  { strcpy(fbp->FuelType, "C2"); fbp->SFL=0.000; fbp->CFL=0.;  fbp->GFL=0.5 * .9 *7.8*pow(1-exp(-0.01976*fbp->BUI),3) + 0.5 * .4 * fbp->C/100.; fbp->C = 100.; }   // Tree Cover, broadleaved, evergreen -- corrected GLF to 50% (from 30%)
        if (feps->glc == 3)  { strcpy(fbp->FuelType, "C2"); fbp->SFL=0.000; fbp->CFL=0.;  fbp->GFL=0.3 * .9 *7.8*pow(1-exp(-0.01976*fbp->BUI),3) + 0.7 * .4 * fbp->C/100.; fbp->C = 100.; }   // Tree Cover, broadleaved, deciduous, open
        if (feps->glc == 12) { strcpy(fbp->FuelType, "C2"); fbp->SFL=0.000; fbp->CFL=0.;  fbp->GFL=0.05 * .9 *7.8*pow(1-exp(-0.01976*fbp->BUI),3) + 0.95 * .4 * fbp->C/100.; fbp->C = 100.; } // Shrub Cover, closed-open, deciduous (value from CFFEPS v11.c = 0.51)
    }

/*** Equatorial Asia ***/
    if (region == 5  && ( feps->glc==7 || feps->glc==8 || feps->glc==9 || feps->glc==11 || feps->glc==14)) 				// Equatorial Asia - tropical peat
        { strcpy(fbp->FuelType, "O1B"); fbp->SFL = 0.; fbp->CFL=0.; fbp->GFL=105.6 /(1.+exp((551.0-fbp->DC)/123.7)); fbp->C = 100.; } 	// new logistic equation -- 2022-09-14


/* Finally, to allow for a mix of shrubs and grass, it is necessary to assign fuel to deciduous(?) to capture woody fuels in FBPCalc() */
    if (!strncasecmp(fbp->FuelType, "O1", 2))
    {
        strcpy(fbp->FuelType, "O1B");
        if (fbp->SFL > 0.) strcpy(fbp->FuelType, "D1"); // allowing for deciduous? shrubs in grass fuel - 2022-03-31
    }

/*** Now modify the grass fuel load by the curing (note for some fuels, curing has been set to 100% ***/
	fbp->GFL = fbp->GFL * fbp->C/100.;

/* Now use Giglio et al regions for the region value */
    feps->region = 0;   // globe
    if (!strncasecmp(feps->giglio, "BONA", 4)) feps->region = 1;
    if (!strncasecmp(feps->giglio, "TENA", 4)) feps->region = 2;
    if (!strncasecmp(feps->giglio, "CEAM", 4)) feps->region = 3;
    if (!strncasecmp(feps->giglio, "NHSA", 4)) feps->region = 4;
    if (!strncasecmp(feps->giglio, "SHSA", 4)) feps->region = 5;
    if (!strncasecmp(feps->giglio, "EURO", 4)) feps->region = 6;
    if (!strncasecmp(feps->giglio, "MIDE", 4)) feps->region = 7;
    if (!strncasecmp(feps->giglio, "NHAF", 4)) feps->region = 8;
    if (!strncasecmp(feps->giglio, "SHAF", 4)) feps->region = 9;
    if (!strncasecmp(feps->giglio, "BOAS", 4)) feps->region = 10;
    if (!strncasecmp(feps->giglio, "CEAS", 4)) feps->region = 11;
    if (!strncasecmp(feps->giglio, "SEAS", 4)) feps->region = 12;
    if (!strncasecmp(feps->giglio, "EQAS", 4)) feps->region = 13;
    if (!strncasecmp(feps->giglio, "AUST", 4)) feps->region = 14;
// printf("... %s %d\n", feps->giglio, feps->region);

// Small Fire Boost
//  for (i=0; i< 15; i++) feps->SFB[i] = SFB[feps->region];
    for (i=0; i< 15; i++) feps->SFB[i] = 1.;	// currently not in use


// Crop Residue Burning -- comment it out to turn off (and leave feps->agfire = false)
	if (feps->glc==16 || //      Cultivated and managed areas
        feps->glc==17 || //      Mosaic: Cropland / Tree Cover / Other natural vegetation
		feps->glc==18)   //      Mosaic: Cropland / Shrub or Grass Cover
		{
		    feps->agfire = true;
			strcpy(fbp->FuelType, "O1B");
			fbp->SFL = 0.;
			fbp->CFL = 0.;
			fbp->GFL = Crops[feps->region]/feps->estarea /10.;	// calculate fuel load from biomass burned per hotspot / hectares per hotspot (tonnes/ha)... /10 to get kg/m2
			feps->GSI = GSI = 0.;	// GSI needs to be 0, 100% cured, to ensure complete burning
			fbp->C = 100.;
//			printf("%d %lf %lf %lf %lf %lf\n", feps->glc, fbp->SFL, fbp->CFL, fbp->GFL, feps->GSI, fbp->C);
		}
	else
		feps->agfire = false;

/* Use GFED fuel consumptions:
	Set all fuel to grass and curing to 100% * /
	{
			strcpy(fbp->FuelType, "O1B");
			fbp->SFL = 0.;
			fbp->CFL = 0.;
			fbp->GFL = FCs[feps->mlc];	// calculate fuel load based on an der Werf's 2017 fuel consumptions (FC) (coverted to kg/m2)
			if (feps->mlc==9 && fbp->LAT > 45) fbp->GFL = 4.0; // Tundra
			if (feps->mlc==11 && fbp->LAT > 45) fbp->GFL = 3.47; // Boreal Peat (use Boreal forest)
			feps->GSI = GSI = 0.;	// GSI needs to be 0, 100% cured, to ensure complete burning
			fbp->C = 100.;
	} */


    /* Now use North American countries for the region value * /
    feps->region = 0;
    if (!strncasecmp(feps->country, "CAN", 3)) feps->region = 1;
    if (!strncasecmp(feps->country, "MEX", 3)) feps->region = 2;
    if (!strncasecmp(feps->country, "USA", 3)) feps->region = 3;*/
// printf("... %s %d\n", feps->giglio, feps->region);


/* New addition */
    if (!strcasecmp(fbp->FuelType, "WA") || !strcasecmp(fbp->FuelType, "NF"))
        status = -1;
    else
        status = 0;

    return (status);

}

double daylength(double lat, int jday)
{
double dtr, x, decl, t, daylength;

//   if (lat<-80. || lat>80. || lng<-180. || lng>180.) exit (-1.);  // removed and replaced with the next line conditional  -- 2022-02-28

    if (lat<-80. || lat>80.)
        daylength=-1;
    else
    {

/* degrees to radians */
        dtr = 3.1415926/180.;

/* fraction of a year */
        x = dtr * 360./366. * (float) jday;

/* solar declination */
        decl = dtr * (0.33029
                - 22.9717 * cos (x) + 3.8346 * sin (x)
                - 0.3495 * cos (2. * x) + 0.0261 * sin (2. * x)
                - 0.1392 * cos (3. * x) + 0.0727 * sin (3. * x));

/* fraction of a day in sunlight */
        t = -tan (dtr * (lat)) * tan (decl)
            + -sin (dtr * 0.8) / (cos (dtr * (lat)) * cos (decl));

/* 24 hrs night: sunrise & sunset = noon */
        if (t < -1. ) t = -1.;

/* 24 hrs daylight: sunrise & sunset = midnight */
        if (t > 1.)   t = 1.;

/* daylength in hours */
        daylength =  2. * (12. / 3.1415926) * acos (t);
    }
    return(daylength);
}


/*-------------------------------------------------------------------
   This subroutine is based on the Growing Season Index from

   Jolly, W.M., Nemani, R. and Running, S.W., 2005. A generalized,
   bioclimatic index to predict foliar phenology in response to climate.
   Global Change Biology, 11(4), pp.619-632.
   -------------------------------------------------------------------*/

double GSIcalc(double T_avg, double T_Min, double T_d, double lat, int Dj)
{
double iGSI, iT_Min, iVPD, iPhoto, Photo, e, es, VPD;

/* these are the test values, which are maintained for this subroutine */
double  T_MMin = -2.,       // oC
        T_MMax = 5.,
        VPD_Min = 900.,     // pascals
        VPD_Max = 4100.,
        Photo_Min = 10,     // hours
        Photo_Max = 11.;

int i;
//printf("00211... %lf %lf %lf %lf %d\n", T_avg,  T_Min,  T_d,  lat,  Dj);
/* Goff-Gratch formula (List 1951) [mb] */

    if (T_d < -60. || T_avg < -60.) // allow for missing data (iVPD will equal 1.)
        VPD = 1.;
    else
    {
        e = pow(10,-7.90298*(373.16/(T_d+273.16)-1.)
                    +5.02808*log10(373.16/(T_d+273.16))
                    -1.3816E-07*(pow(10,11.344*(1.-((T_d+273.16)/373.16)))-1.)
                    +8.1328E-03*(pow(10,-3.49149*((373.16/(T_d+273.16))-1))-1.)
                    +log10(1013.246));

        es = pow(10,-7.90298*(373.16/(T_avg+273.16)-1.)
                    +5.02808*log10(373.16/(T_avg+273.16))
                    -1.3816E-07*(pow(10,11.344*(1.-((T_avg+273.16)/373.16)))-1.)
                    +8.1328E-03*(pow(10,-3.49149*((373.16/(T_avg+273.16))-1))-1.)
                    +log10(1013.246));

        VPD = 100.*(es - e);    // based on T_avg and T_d [pa]
    }

    if (T_Min<= T_MMin)
        iT_Min = 0.;
    else if (T_Min>= T_MMax)
        iT_Min = 1.;
    else
        iT_Min = (T_Min - T_MMin)/(T_MMax - T_MMin);

    if (VPD>= VPD_Max)
        iVPD = 0.;
    else if (VPD <= VPD_Min)
        iVPD = 1.;
    else
        iVPD = 1. - (VPD - VPD_Min)/(VPD_Max - VPD_Min);

    Photo = daylength(lat, Dj);

    if (Photo <= Photo_Min)
        iPhoto = 0;
    else if (Photo >= Photo_Max)
        iPhoto = 1;
    else
        iPhoto = (Photo - Photo_Min)/(Photo_Max - Photo_Min);

//    iT_Min = 1.;
//    iVPD = 1.;
//    iPhoto = 1.;

    iGSI = iT_Min * iVPD * iPhoto;
//    printf("%lf = %lf * %lf * %lf\n", iGSI, iT_Min, iVPD, iPhoto);
//    iGSI = 0.;
//    iGSI = 1.;
    if (iGSI < 0.001) iGSI = 0.001;
    if (iGSI > 0.999) iGSI = 0.999;


    return(iGSI);
}


int Peatland(char *FBPstr, char *description, double DC, double k)
{
/*  Thompson, D.K., Simpson, B.N., Whitman, E., Barber, Q.E. and Parisien, M.A., 2019.
    Peatland hydrological dynamics as a driver of landscape connectivity and fire
    activity in the boreal plain of Canada. Forests, 10(7), p.534.

Determines best representative fuel type for bogs and fens, includes:

    open bog
    treed bog
    forested bog
    open poor fen
    treed poor fen
    forested poor fen
    open rich fen
    treed rich fen
    forested rich fen
*/

    if (!strcasecmp(FBPstr, "C3"))  strcpy(FBPstr, description);
    if (!strcasecmp(FBPstr, "C4"))  strcpy(FBPstr, description);

    if (DC < 250)
    {
        if (!strcasecmp("open rich fen", description) ||
            !strcasecmp("treed rich fen", description))
            strcpy(FBPstr, "NF");
        else
            strcpy(FBPstr, "D2");
    }
    else if (DC < 750)
    {
        if (!strcasecmp("treed bog", description) ||
            !strcasecmp("forested bog", description) ||
            !strcasecmp("open poor fen", description) ||
            !strcasecmp("treed poor fen", description) ||
            !strcasecmp("forested poor fen", description) )
            strcpy(FBPstr, description);
        else if (!strcasecmp("open rich fen", description) )
            strcpy(FBPstr, "NF");
        else
            strcpy(FBPstr, "D2");
    }
    else
          strcpy(FBPstr, description);

}


int ReadHotspotHeader(char *buffer, FIELDS *fields)
{
char *token;
int i;

    fields->lat = -1;
    fields->lon = -1;
    fields->rep_date = -1;
    fields->spot = -1;
    fields->source = -1;
    fields->sensor = -1;
    fields->temp = -1;    // this is doubled up
    fields->td = -1;    //  2022-05-25
    fields->rh = -1;
    fields->ws = -1;
    fields->wd = -1;
    fields->pcp = -1;
    fields->ffmc = -1;
    fields->dmc = -1;
    fields->dc = -1;
    fields->isi = -1;
    fields->fwi = -1;
    fields->estarea = -1;
    fields->pcuring = -1;
    fields->greenup = -1;
    fields->elev = -1;
    fields->fuel = -1;
    fields->ros = -1;
    fields->sfc = -1;
    fields->tfc = -1;
    fields->bfc = -1;
    fields->hfi = -1;
    fields->slope = -1;
    fields->aspect = -1;
    fields->pconif = -1;
    fields->pdf = -1;
    fields->cbh = -1;
    fields->gfl = -1;
    fields->sfl = -1;
    fields->cfl = -1;
    fields->ffl = -1;
    fields->wfl = -1;
    fields->lfl = -1;
    fields->dfl = -1;
    fields->hfl = -1;
    fields->sh = -1;
    fields->sd = -1;
    fields->UTC = -1;
    fields->tmin_met = -1;  // KRA 2022-02-24
    fields->tavg_met = -1;  // KRA 2023-09-15
    fields->tdavg_met = -1;  // KRA 2023-09-15
    fields->temp_met = -1;
    fields->rh_met = -1;
    fields->zs_met = -1;
    fields->ws_met = -1;
    fields->Precip_rate = -1;
    fields->ts = -1;
    fields->t850 = -1;
    fields->t700 = -1;
    fields->t500 = -1;
    fields->t250 = -1;
    fields->zs = -1;
    fields->z850 = -1;
    fields->z700 = -1;
    fields->z500 = -1;
    fields->z250 = -1;

    fields->glc_region = -1;
    fields->glc = -1;
    fields->country = -1;
    fields->region = -1;
    fields->giglio = -1;
    fields->pressure = -1;

    // New 2015 GFFEPS fields (some redundancy) -- KRA: 2022-02-24
    fields->tmin_met = -1;
    fields->FRP = -1;
    fields->mlc = -1;
    fields->gsi = -1.;  // KRA 2023-03-23
    fields->gsi01 = -1.;  // KRA 2023-03-23
    fields->gsi07 = -1.;  // KRA 2023-03-23
    fields->gsi14 = -1.;  // KRA 2023-03-23
    fields->gsi21 = -1.;  // KRA 2023-03-23

    i = 0;
// read in the header
    token = strtok(buffer, ",");
    while (token != NULL && i < 100)
    {
        if (token[0]==' ') token++; // remove a blank first character

        if (!strncasecmp(token, "lat", 3 ) ) fields->lat = i;
        if (!strncasecmp(token, "lon", 3 ) ) fields->lon = i;
        if (!strncasecmp(token, "rep_date", 3 ) ) fields->rep_date = i;
        if (!strncasecmp(token, "spot", 3 ) ) fields->spot = i;
        if (!strncasecmp(token, "source", 3 ) ) fields->source = i;
        if (!strncasecmp(token, "sensor", 3 ) ) fields->sensor = i;
        if (!strncasecmp(token, "temp", 3 ) )
            if (fields->temp == -1) fields->temp = i;
            else fields->temp_met = i;
        if (!strncasecmp(token, "rh", 2) ) // this is doubled up
            if (fields->rh == -1) fields->rh = i;
            else fields->rh_met = i;
        if (!strncasecmp(token, "TD", 2) ) fields->td = i;    //  2022-05-25
        if (!strncasecmp(token, "ws", 2) ||
            !strncasecmp(token, "UV", 2) ) fields->ws = i;
        if (!strncasecmp(token, "wd", 2) ) fields->wd = i;
        if (!strncasecmp(token, "pcp", 3 ) ) fields->pcp = i;
        if (!strncasecmp(token, "ffmc", 3 ) ) fields->ffmc = i;
        if (!strncasecmp(token, "dmc", 3 ) ) fields->dmc = i;
        if (!strncasecmp(token, "dc", 2) ) fields->dc = i;
        if (!strncasecmp(token, "isi", 3 ) ) fields->isi = i;
        if (!strncasecmp(token, "fwi", 3 ) ) fields->fwi = i;
        if (!strncasecmp(token, "estarea", 3 ) ) fields->estarea = i;
        if (!strncasecmp(token, "pcuring", 3 ) ) fields->pcuring = i;
        if (!strncasecmp(token, "greenup", 3 ) ) fields->greenup = i;
        if (!strncasecmp(token, "elev", 3 ) ) fields->elev = i;
        if (!strncasecmp(token, "fuel", 3 ) ) fields->fuel = i;
        if (!strncasecmp(token, "ros", 3 ) ) fields->ros = i;
        if (!strncasecmp(token, "sfc", 3 ) ) fields->sfc = i;
        if (!strncasecmp(token, "tfc", 3 ) ) fields->tfc = i;
        if (!strncasecmp(token, "bfc", 3 ) ) fields->bfc = i;
        if (!strncasecmp(token, "hfi", 3 ) ) fields->hfi = i;
        if (!strncasecmp(token, "slope", 3 ) ) fields->slope = i;
        if (!strncasecmp(token, "aspect", 3 ) ) fields->aspect = i;
        if (!strncasecmp(token, "pconif", 3 ) ) fields->pconif = i;
        if (!strncasecmp(token, "pdf", 3 ) ) fields->pdf = i;
        if (!strncasecmp(token, "cbh", 3 ) ) fields->cbh = i;
        if (!strncasecmp(token, "gfl", 3 ) ) fields->gfl = i;
        if (!strncasecmp(token, "sfl", 3 ) ) fields->sfl = i;
        if (!strncasecmp(token, "cfl", 3 ) ) fields->cfl = i;
        if (!strncasecmp(token, "ffl", 3 ) ) fields->ffl = i;
        if (!strncasecmp(token, "wfl", 3 ) ) fields->wfl = i;
        if (!strncasecmp(token, "lfl", 3 ) ) fields->lfl = i;
        if (!strncasecmp(token, "dfl", 3 ) ) fields->dfl = i;
        if (!strncasecmp(token, "hfl", 3 ) ) fields->hfl = i;
        if (!strncasecmp(token, "sh", 3 ) ) fields->sh = i;
        if (!strncasecmp(token, "sd", 3 ) ) fields->sd = i;
        if (!strncasecmp(token, "UTC", 3 ) ) fields->UTC = i;
        if (!strncasecmp(token, "zs-met", 3 ) ) fields->zs_met = i;
        if (!strncasecmp(token, "ws-met", 3 ) ) fields->ws_met = i;
        if (!strncasecmp(token, "wd-met", 3 ) ) fields->wd_met = i;
        if (!strncasecmp(token, "Precip rate", 3 ) ) fields->Precip_rate = i;
        if (!strncasecmp(token, "ts", 3 ) ) fields->ts = i;
        if (!strncasecmp(token, "t850", 3 ) ) fields->t850 = i;
        if (!strncasecmp(token, "t700", 3 ) ) fields->t700 = i;
        if (!strncasecmp(token, "t500", 3 ) ) fields->t500 = i;
        if (!strncasecmp(token, "t250", 3 ) ) fields->t250 = i;
        if (!strcasecmp(token, "zs" ) ) fields->zs = i;
        if (!strncasecmp(token, "z850", 3 ) ) fields->z850 = i;
        if (!strncasecmp(token, "z700", 3 ) ) fields->z700 = i;
        if (!strncasecmp(token, "z500", 3 ) ) fields->z500 = i;
        if (!strncasecmp(token, "z250", 3 ) ) fields->z250 = i;

        if (!strcasecmp(token, "glc_region") ) fields->glc_region = i;
        if (!strcasecmp(token, "glc" ) ) fields->glc = i;
        if (!strcasecmp(token, "country_code" ) ) fields->country = i;
        if (!strcasecmp(token, "region" ) ) fields->giglio= i;

        if (!strcasecmp(token, "P0") ) fields->pressure = i;
        if (!strcasecmp(token, "PR") ) fields->Precip_rate = i;
        if (!strcasecmp(token, "HR1015") ) fields->rh_met = i;
        if (!strcasecmp(token, "UUVV") ) fields->ws_met = i;
        if (!strcasecmp(token, "T0") ) fields->temp_met = i;

// New 2015 GFFEPS fields (some redundancy) -- KRA: 2022-02-24
        if (!strcasecmp(token, "TTMN") ) fields->tmin_met = i;
        if (!strcasecmp(token, "TTAV") ) fields->tavg_met = i;		// 2023-09-15
        if (!strcasecmp(token, "TDAV") ) fields->tdavg_met = i;		// 2023-09-15
        if (!strcasecmp(token, "P0") ) fields->pressure = i;
        if (!strcasecmp(token, "TT") ) fields->temp_met = i;
        if (!strcasecmp(token, "HR") ) fields->rh_met = i;
        if (!strcasecmp(token, "PR") ) fields->Precip_rate = i;
        if (!strcasecmp(token, "UV") ) fields->ws_met = i;
        if (!strcasecmp(token, "FRP") ) fields->FRP = i;
        if (!strcasecmp(token, "modis_lc") ) fields->mlc = i;
        if (!strcasecmp(token, "GSI") ) fields->gsi = i;
        if (!strcasecmp(token, "GSI01") ) fields->gsi01 = i;
        if (!strcasecmp(token, "GSI07") ) fields->gsi07 = i;
        if (!strcasecmp(token, "GSI14") ) fields->gsi14 = i;
        if (!strcasecmp(token, "GSI21") ) fields->gsi21 = i;


        // rep_date,latitude,longitude,modis_lc,glc_region,glc,country_code,region,estarea,frp,UTC,FFMC,DMC,DC,FWI,BUI,ISI,TT,TD,PR,UV     //  new header file fields -- 2022-05-25

        token = strtok(NULL, ",");
        i++;
    }

    if (fields->temp == -1) fields->temp = fields->temp_met;
    if (fields->rh == -1) fields->rh = fields->rh_met;
    if (fields->ws == -1) fields->ws = fields->ws_met;

    fields->columns = i;

    return(i);
}

int ReadHotspotData(char *buffer, FIELDS *fields, FEPS *feps, FBP *fbp, UA *ua)
{
char *args[100], *token, fuel[12];
int i, iii, iday, imonth, iyear, greenup, standing, status;
static int jdays[] = {0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334};
    status = true;
// printf("%s\n", buffer);
// printf("Hello from ReadHotspotData\n\n");
    for (i=0;i<100;i++)
        args[i] = (char *)calloc(12, sizeof(char));

// read in the data
    i=0;
    token = strtok(buffer, ",");
//    while (token != NULL && i < 100)
    while (i < fields->columns)
    {
//    printf("%d %d '%s'\n", i, fields->columns, token);
        if (token == NULL)
            strcpy(args[i], "X");
        else
            strcpy(args[i], token);
        token = strtok(NULL, ",");
        i++;
    }

// in case CMC hourly forecast not present (i.e., BIGFOOT)
    feps->ws = -1;
    feps->GSI = -1;

    if (fields->lat >=0) fbp->LAT = atof(args[fields->lat]);                   // latitude [degrees]
    if (fields->lon >=0) fbp->LON = atof(args[fields->lon]);                   // longitude [degrees]

    if (fields->rep_date >=0) strcpy(feps->rep_date, args[fields->rep_date]);  // report date [YYYY-MM-DD HH:MM;SS] or [YYYY-MM-DD H:MM;SS]

// Fields not used by CFFEPS commented out
//        if (fields->spot >=0) strcpy(spot, args[fields->spot]);             // spot [province/territory/state]
    if (fields->source >=0) strcpy(feps->source, args[fields->source]);
    if (fields->sensor >=0) strcpy(feps->sensor, args[fields->sensor]);

// CWFIS observed noon data - overwritten later with CMC hourly data
    if (fields->temp >=0) feps->temp = atof(args[fields->temp]);   // CWFIS noon temperature [oC]
    if (fields->rh >=0) feps->rh = atof(args[fields->rh]);         // CWFIS noon relative humidity [%]
    if (fields->td >=0 && fields->rh < 0)  feps->rh = 100.* e_w_Calc(atof(args[fields->td]))/e_w_Calc(atof(args[fields->temp]));
    if (fields->ws >=0) fbp->WS = atof(args[fields->ws]);          // CWFIS wind speed [km/h]
    if (fields->wd >=0) fbp->WD = atof(args[fields->wd]);          // CWFIS wind direction [o]
    if (fields->pcp >=0) feps->precip = atof(args[fields->pcp]);   // CWFIS 24 hour precipitation measured at noon [mm]

    if (fields->ffmc >=0) fbp->FFMC= atof(args[fields->ffmc]); // Fine Fuel Moisture Code [noon] -- overwritten with recalculated hourly data
    if (fields->dmc >=0) feps->DMC= atof(args[fields->dmc]);   // Duff Fuel Moisture Code
    if (fields->dc >=0) feps->DC= atof(args[fields->dc]);      // Drought Code
       fbp->DMC = feps->DMC;
       fbp->DC = feps->DC;

// Fields not used by CFFEPS commented out
//        if (fields->isi >=0) isi= atof(args[fields->isi]);
    if (fields->fwi >=0) feps->FWI= atof(args[fields->fwi]);

    if (fields->estarea >=0) feps->estarea= atof(args[fields->estarea]);     // estimate size of hotspot [ha]

    if (fields->pcuring >=0) fbp->C= atof(args[fields->pcuring]);      // grass curing [%]
//        if (fields->greenup >=0) greenup = atof(args[fields->greenup]);     // greenup -- not used
    if (fields->elev >=0) fbp->ELV = atof(args[fields->elev]);         // elevation [m]
//    if (fields->elev >=0) feps->zs = atof(args[fields->elev]);         // elevation [m]
        if (fields->fuel >=0) strcpy(fuel, args[fields->fuel]);        // char length 12 -- later set to fbp->FuelType -- 2020-06-10

// Fields not used by CFFEPS commented out
//        if (fields->ros >=0) ros = atof(args[fields->ros]);
//        if (fields->sfc >=0) sfc = atof(args[fields->sfc]);
//        if (fields->tfc >=0) tfc = atof(args[fields->tfc]);
//        if (fields->bfc >=0) bfc = atof(args[fields->bfc]);
//        if (fields->hfi >=0) hfi = atof(args[fields->hfi]);

    if (fields->slope >=0) fbp->GS = atof(args[fields->slope]);        // ground slope [%]
    if (fields->aspect >=0) fbp->Aspect = atof(args[fields->aspect]);  // aspect [degrees]
    if (fields->pconif >=0) fbp->PC = atof(args[fields->pconif]);      // percent coniferous [%]
    if (fields->pdf >=0) fbp->PDF = atof(args[fields->pdf]);           // percent dead foliar [&]
    if (fields->cbh >=0) fbp->CBH = atof(args[fields->cbh]);           // crown to base height [m]
    if (fields->gfl >=0) fbp->GFL = atof(args[fields->gfl]);           // grass fuel load [kg/m2]
    if (fields->sfl >=0) fbp->SFL = atof(args[fields->sfl]);           // surface fuel load [kg/m2]
    if (fields->cfl >=0) fbp->CFL = atof(args[fields->cfl]);           // crown fuel load [kg/m2]
    if (fields->ffl >=0) fbp->FFL = atof(args[fields->ffl]);           // fine fuel load [kg/m2]
    if (fields->wfl >=0) fbp->WFL = atof(args[fields->wfl]);           // woody fuel load [kg/m2]
    if (fields->lfl >=0) fbp->LFL = atof(args[fields->lfl]);           // litter fuel load [kg/m2]
    if (fields->dfl >=0) fbp->DFL = atof(args[fields->dfl]);           // duff fuel load [kg/m2]
    if (fields->hfl >=0) fbp->HFL = atof(args[fields->hfl]);           // humus fuel load [kg/m2]
    if (fields->sh >=0) fbp->SH = atof(args[fields->sh]);              // Stand Height [m]
    if (fields->sd >=0) fbp->SD = atof(args[fields->sd]);              // Stand Density [trees/ha]

// CMC hourly forecast data
    if (fields->UTC >=0) strcpy(feps->cmc_date, args[fields->UTC]);     // CMC forecast date in UTC [YYYYMMDD_HH:MM]
        if (feps->print<0 && strlen(feps->cmc_date)<11) printf("2.b. Warning: incomplete cmc_date (%s)\n", feps->cmc_date);

    if (fields->temp_met >=0) feps->temp = atof(args[fields->temp_met]);// temp = Surface temperature (degrees Celsius)
    if (fields->rh_met >=0) feps->rh = atof(args[fields->rh_met]);      //rh = Surface relative humidity (fraction - unitless)
    if (fields->zs_met >=0) feps->zs = atof(args[fields->zs_met]);      // zs =  Surface geopotential height (dam)
    if (fields->ws_met >=0) feps->ws = atof(args[fields->ws_met]);      // ws-met =  Surface wind speed (knots)
    if (fields->wd_met >=0) feps->wd = atof(args[fields->wd_met]);      // ws-met =  Surface wind speed (knots)
    if (fields->Precip_rate >=0) feps->precip = atof(args[fields->Precip_rate]);     // Precip rate = Total precipitation rate (m/s)
    if (fields->ts >=0) feps->ts = atof(args[fields->ts]);        // TS = Surface and soil temperatures (Superficial) (degree Kelvin)
    if (fields->t850 >=0) feps->t850 = atof(args[fields->t850]);  // T850 = Temperature @ 850 mb (degrees Celsius)
    if (fields->t700 >=0) feps->t700 = atof(args[fields->t700]);  // T700 = Temperature @ 700 mb (degrees Celsius)
    if (fields->t500 >=0) feps->t500 = atof(args[fields->t500]);  // T500 = Temperature @ 500 mb (degrees Celsius)
    if (fields->t250 >=0) feps->t250 = atof(args[fields->t250]);  // T250 = Temperature @ 250 mb (degrees Celsius)
    if (fields->zs >=0) feps->zs = atof(args[fields->zs]);      // zs =  Surface geopotential height (dam)
    if (fields->z850 >=0) feps->z850 = atof(args[fields->z850]);  // Z850 = Geopotential height @ 850 mb (dam)
    if (fields->z700 >=0) feps->z700 = atof(args[fields->z700]);  // Z700 = Geopotential height @ 700 mb (dam)
    if (fields->z500 >=0) feps->z500 = atof(args[fields->z500]);  // Z500 = Geopotential height @ 500 mb (dam)
    if (fields->z250 >=0) feps->z250 = atof(args[fields->z250]);  // Z250 = Geopotential height @ 250 mb (dam)

    if (fields->glc_region >=0) strcpy(feps->glc_region, args[fields->glc_region]);   // GLC2000 region [A-S]
    if (fields->glc >=0) feps->glc = atoi(args[fields->glc]);  //GLC 2000 land classification
    if (fields->country >=0) strcpy(feps->country, args[fields->country]);  // Country
    if (fields->giglio >=0) strcpy(feps->giglio, args[fields->giglio]);  // region as defined by Giglio et al 2006

    if (fields->pressure >=0) feps->pressure = atof(args[fields->pressure]);  // pressure = Surface pressure (mb)

// New 2015 GFFEPS fields (some redundancy) -- KRA: 2022-02-24
    if (fields->tmin_met >=0) feps->tmin = atof(args[fields->tmin_met]);
    if (fields->tavg_met >=0) feps->tavg = atof(args[fields->tavg_met]);	// 2023-09-15
    if (fields->tdavg_met >=0) feps->tdavg = atof(args[fields->tdavg_met]);	// 2023-09-15

    if (fields->FRP >=0) feps->FRP = atof(args[fields->FRP]);
    if (fields->mlc >=0) feps->mlc = atoi(args[fields->mlc]);  //MODIS MCD12C1 land classification
    if (fields->gsi >=0) feps->GSI = atof(args[fields->gsi]);  // Growing Season Index (Jolly et al. 2005)
    if (fields->gsi01 >=0) feps->GSI01 = atof(args[fields->gsi01]);  // Growing Season Index (Jolly et al. 2005)
    if (fields->gsi07 >=0) feps->GSI07 = atof(args[fields->gsi07]);  // Growing Season Index (Jolly et al. 2005)
    if (fields->gsi14 >=0) feps->GSI14 = atof(args[fields->gsi14]);  // Growing Season Index (Jolly et al. 2005)
    if (fields->gsi21 >=0) feps->GSI21 = atof(args[fields->gsi21]);  // Growing Season Index (Jolly et al. 2005)


///////////////////////////////////

// Correct to acceptable fuel types
    strcpy(fbp->FuelType, fuel);// fuel[12] set to fbp->FuelType[6] -- some information may be truncated

    if (!strcasecmp(fbp->FuelType, "O1") ) strcpy(fbp->FuelType, "O1b");
    if (!strcasecmp(fbp->FuelType,"cropland")) strcpy(fbp->FuelType, "O1a");
    if (!strcasecmp(fbp->FuelType,"low_veg")) strcpy(fbp->FuelType, "O1a");
    if (!strcasecmp(fbp->FuelType,"urban")) strcpy(fbp->FuelType, "NF");
    if (!strcasecmp(fbp->FuelType,"bog")) strcpy(fbp->FuelType, "NF");
    if (!strcasecmp(fbp->FuelType,"water")) strcpy(fbp->FuelType, "NF");
    if (!strcasecmp(fbp->FuelType,"non_fuel")) strcpy(fbp->FuelType, "NF");
    if (!strncasecmp(fbp->FuelType,"M1", 2)) strcpy(fbp->FuelType, "M1");
    if (!strncasecmp(fbp->FuelType,"M2", 2)) strcpy(fbp->FuelType, "M2");
    if (!strncasecmp(fbp->FuelType,"M3", 2)) strcpy(fbp->FuelType, "M3");
    if (!strncasecmp(fbp->FuelType,"M4", 2)) strcpy(fbp->FuelType, "M4");
    if (!strcasecmp(fbp->FuelType,"D2")) strcpy(fbp->FuelType, "D1");

    if ((!strncasecmp(fbp->FuelType,"M1", 2)) && atof(&fuel[3])>0) fbp->PC = atof(&fuel[3]);
    if ((!strncasecmp(fbp->FuelType,"M2", 2)) && atof(&fuel[3])>0) fbp->PC = atof(&fuel[3]);
    if ((!strncasecmp(fbp->FuelType,"M3", 2)) && atof(&fuel[3])>0) fbp->PDF = atof(&fuel[3]);
    if ((!strncasecmp(fbp->FuelType,"M4", 2)) && atof(&fuel[3])>0) fbp->PDF = atof(&fuel[3]);

// if there is no matching FuelType to FBP, set to NF
    if (! ( !strcasecmp(fbp->FuelType, "C1") ||
            !strcasecmp(fbp->FuelType, "C2") ||
            !strcasecmp(fbp->FuelType, "C3") ||
            !strcasecmp(fbp->FuelType, "C4") ||
            !strcasecmp(fbp->FuelType, "C5") ||
            !strcasecmp(fbp->FuelType, "C6") ||
            !strcasecmp(fbp->FuelType, "C7") ||
            !strcasecmp(fbp->FuelType, "D1") ||
            !strcasecmp(fbp->FuelType, "D2") ||
            !strcasecmp(fbp->FuelType, "M1") ||
            !strcasecmp(fbp->FuelType, "M2") ||
            !strcasecmp(fbp->FuelType, "M3") ||
            !strcasecmp(fbp->FuelType, "M4") ||
            !strcasecmp(fbp->FuelType, "S1") ||
            !strcasecmp(fbp->FuelType, "S2") ||
            !strcasecmp(fbp->FuelType, "S3") ||
            !strcasecmp(fbp->FuelType, "O1") ||
            !strcasecmp(fbp->FuelType, "O1a") ||
            !strcasecmp(fbp->FuelType, "O1b") ) )
        strcpy(fbp->FuelType, "NF");

/* / use FBP default values
    if (fbp->FC_method == 1)
    {
        fbp->C = -1.;
        fbp->ELV = -1.;

        fbp->GS = -1.;
        fbp->Aspect = -1.;
        fbp->PC = -1.;
        fbp->PDF = -1.;
        fbp->CBH = -1.;
        fbp->GFL = -1.;
        fbp->SFL = -1.;  // use the default FBP values for SFL

        fbp->CFL = -1.;
        fbp->FFL = -1.;
        fbp->WFL = -1.;
        fbp->SH = -1.;
        fbp->SD = -1.;
    } */

// some values may be reported in Kelvin
    if (feps->temp > 100.) feps->temp = feps->temp - 273.16;
    if (feps->ts > 100.) feps->ts = feps->ts - 273.16;
    if (feps->t850 > 100.) feps->t850 = feps->t850 - 273.16;
    if (feps->t700 > 100.) feps->t700 = feps->t700 - 273.16;
    if (feps->t500 > 100.) feps->t500 = feps->t500 - 273.16;
    if (feps->t250 > 100.) feps->t250 = feps->t250 - 273.16;

// in case RH is reported as a fraction
    if (feps->rh < 1.) feps->rh = 100.*feps->rh;

    if (feps->ws < 0.)
        feps->ws = fbp->WS; /* use CWFIS/BIGFOOT wind speed */
    else
        feps->ws = 1.852 * feps->ws;  /* CMC knots to km/hr */

    if (strncmp(feps->diurnal, "OFF",3) && feps->ws >=0.) fbp->WS = feps->ws; /* if OFF, maintain the CWFIS fbp->WS for diurnal calculations; otherwise, use the feps->ws -- 2020-06-05 */

    if (feps->precip >= 0.)
        if (fields->Precip_rate >=0) /* CMC forecast data present */
            feps->precip = 3600000.* feps->precip;  /* m/s to mm/hr -- CMC forecasted rate */
//        else
//            feps->precip = 0.;  /* assume CWFIS rain does not persist */

// in case heights are reported in decametres
    if (feps->z850 < 500. && fields->zs != -1 &&     fields->zs_met != -1) feps->zs = 10.* feps->zs;  // in the case of the surface (if fields preesent), assume that the units are the same as those for 850 mb
    if (feps->z850 < 500.) feps->z850 = 10.* feps->z850;
    if (feps->z700 < 1000.) feps->z700 = 10.* feps->z700;
    if (feps->z500 < 1000.) feps->z500 = 10.* feps->z500;
    if (feps->z250 < 2000.) feps->z250 = 10.* feps->z250;

    feps->zt = feps->z250;    // arbitrarily setting the plume top to 250 mb

    feps->ts = feps->temp;    // ALWAYS use the field "temp" -- 2019-07-17

/* 2.c. Assign upper air values into arrays uP, uZ and uT for future use in PlumeCalcDry (under development) */
    ua->iLevels=0;

    ua->P[0] = 1000.;     // should use surface pressure but am using 1000 mb for now

    ua->P[0] = 850.-(feps->z850-feps->zs)/(feps->z700-feps->z850)*(700.-850.);
    ua->Z[0] = feps->zs;
    ua->T[0] = feps->ts;
    ua->Td[0] = T_d_Calc(feps->ts, feps->rh);  // for use in PlumeCalcWet

    ua->iLevels++;

    if (feps->z850 > feps->zs)
    {
        ua->P[ua->iLevels] = 850.;
        ua->Z[ua->iLevels] = feps->z850;
        ua->T[ua->iLevels] = feps->t850;
        ua->iLevels++;
    }

    if (feps->z700 > feps->zs)
    {
        ua->P[ua->iLevels] = 700.;
        ua->Z[ua->iLevels] = feps->z700;
        ua->T[ua->iLevels] = feps->t700;
        ua->iLevels++;
    }

    ua->P[ua->iLevels] = 500.;
    ua->Z[ua->iLevels] = feps->z500;
    ua->T[ua->iLevels] = feps->t500;
    ua->iLevels++;

    ua->P[ua->iLevels] = 250.;
    ua->Z[ua->iLevels] = feps->z250;
    ua->T[ua->iLevels] = feps->t250;
    ua->iLevels++;

    ua->P[ua->iLevels] = 100.;
    ua->Z[ua->iLevels] = feps->z250*2;
    ua->T[ua->iLevels] = feps->t250;    // assuming isothermic above 250 mb
    ua->iLevels++;

/* 2.f. Determine time zone (longitude/15) and parse detection date and time.
        Adjust detection time from UTC to local time such that noon is at solar zenith .
        Adjust LDT to LST (hardcoded to LST?).
        Determine UTC and LST time of the forecast record. */
if (feps->print==-2) printf("2.f. '%s'\n", feps->cmc_date);

// do not use default feps data -- 2020-06-11
//            if (feps->timezone>= -24 && feps->timezone <= 24)
//                timezone = (double)feps->timezone;
//            else
    feps->timezone = (fbp->LON)/15.;  // ignore the timezone in the input file
    feps->LDT = 0.;

/* Determine detection date and time */
            // 2014-04-01 20:01:00 or
            // 2018-06-15 2:47

// e.g. 20160216_00:00
    feps->fdate = atoi(&feps->cmc_date[0]);
    feps->ftime = atoi(&feps->cmc_date[9])*100 + atoi(&feps->cmc_date[12]);    // currently in UTC HHMM

    feps->ddate = atoi(&feps->rep_date[0])*10000 + atoi(&feps->rep_date[5])*100 + atoi(&feps->rep_date[8]);
    if (atoi(&feps->rep_date[11]) < 10.)
        feps->dtime  = atoi(&feps->rep_date[11])*100 + atoi(&feps->rep_date[13]);    // currently in UTC
    else
        feps->dtime  = atoi(&feps->rep_date[11])*100 + atoi(&feps->rep_date[14]);    // currently in UTC

//            feps->timestep = 1.;

/* Determine julian date */
//  if (fbp->Dj = -1)
//  {
        if (feps->ddate > 9999)
            iyear = (int)(feps->ddate/10000);
        else
            iyear = 0;
        imonth = (int)((feps->ddate-10000*iyear)/100);
        iday = feps->ddate-10000*iyear-100*imonth;
        fbp->Dj = jdays[imonth-1]+iday;
        if (iyear > 0 && iyear%4 == 0 && imonth >2) fbp->Dj+=1;
//  }

/* Adjust LDT value to LST */
    if (feps->LDT == 100 || feps->LDT == 1)
       feps->LDT = 1;
    else
       feps->LDT = 0;

/* 2.g. Recalculate the BUI value from DMC and DC values.  Determine whether the BUI effect is being used. */
if (feps->print==-2) printf("2.g. '%s'\n", feps->rep_date);
    fbp->BUI = BUIcalc(feps->DMC, feps->DC);

/* If BUI is zero or less, BUIeff = False */
    if (fbp->BUI <= 0) fbp->BUIEff = -1;

    if (fields->glc >=0)
        status = GLC2000Type(feps, fbp);    /* GLC2000 Fuel type, used in GFFEPS -- 2021-04-16 */

    return (status);

}
